import 'package:dio/dio.dart';

class AppResponse<T> {
  final dynamic error;
  final T? data;

  AppResponse({
    this.data,
    this.error,
  });
}

class HttpResponse<T> {
  final T data;
  final Response response;
  HttpResponse(this.data, this.response);
}

class BaseResponse<T> {
  T? values;

  BaseResponse({
    this.values,
  });

  factory BaseResponse.fromJson(
    Map<String, dynamic> json,
    T Function(dynamic json) fromJsonT,
  ) =>
      _$BaseResponseFromJson(json, fromJsonT);
}

BaseResponse<T> _$BaseResponseFromJson<T>(
  Map<String, dynamic> json,
  T Function(Object? json) fromJsonT,
) {
  return BaseResponse<T>(
    values: _$nullableGenericFromJson(json['values'], fromJsonT),
  );
}

T? _$nullableGenericFromJson<T>(
  Object? input,
  T Function(Object? json) fromJson,
) =>
    fromJson(input);
