class Country {
  String? iso;
  String? name;
  String? printableName;
  String? iso3;
  int? numcode;
  int? available;
  int? phoneAvailable;
  int? eventAvailable;
  int? missionAvailable;
  String? phoneCode;

  Country(
      {this.iso,
      this.name,
      this.printableName,
      this.iso3,
      this.numcode,
      this.available,
      this.phoneAvailable,
      this.eventAvailable,
      this.missionAvailable,
      this.phoneCode});

  Country.fromJson(Map<String, dynamic> json) {
    iso = json["iso"];
    name = json["name"];
    printableName = json["printableName"];
    iso3 = json["iso3"];
    numcode = json["numcode"];
    available = json["available"];
    phoneAvailable = json["phoneAvailable"];
    eventAvailable = json["eventAvailable"];
    missionAvailable = json["missionAvailable"];
    phoneCode = json["phoneCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["iso"] = iso;
    _data["name"] = name;
    _data["printableName"] = printableName;
    _data["iso3"] = iso3;
    _data["numcode"] = numcode;
    _data["available"] = available;
    _data["phoneAvailable"] = phoneAvailable;
    _data["eventAvailable"] = eventAvailable;
    _data["missionAvailable"] = missionAvailable;
    _data["phoneCode"] = phoneCode;
    return _data;
  }

  Country copyWith({
    String? iso,
    String? name,
    String? printableName,
    String? iso3,
    int? numcode,
    int? available,
    int? phoneAvailable,
    int? eventAvailable,
    int? missionAvailable,
    String? phoneCode,
  }) =>
      Country(
        iso: iso ?? this.iso,
        name: name ?? this.name,
        printableName: printableName ?? this.printableName,
        iso3: iso3 ?? this.iso3,
        numcode: numcode ?? this.numcode,
        available: available ?? this.available,
        phoneAvailable: phoneAvailable ?? this.phoneAvailable,
        eventAvailable: eventAvailable ?? this.eventAvailable,
        missionAvailable: missionAvailable ?? this.missionAvailable,
        phoneCode: phoneCode ?? this.phoneCode,
      );
}
