import '_model.dart';

class CrmLead {
  int? isPro;
  String? firstName;
  String? lastName;
  String? email;
  String? website;
  String? mobilePhone;
  String? mobilePrefix;
  String? fixPhone;
  String? fixPrefix;
  int? organisationId;
  String? street;
  String? zip;
  String? city;
  String? state;
  String? country;
  int? statusId;
  String? comment;
  String? mainLanguage;
  String? secondaryLanguage;
  int? crmOrganisationId;
  int? id;
  String? uuid;
  int? createdBy;
  int? createdAt;
  int? deletedAt;
  CrmStatus? status;
  String? thumbnail;

  CrmLead({
    this.isPro,
    this.firstName,
    this.lastName,
    this.email,
    this.website,
    this.mobilePhone,
    this.mobilePrefix,
    this.fixPhone,
    this.fixPrefix,
    this.organisationId,
    this.street,
    this.zip,
    this.city,
    this.state,
    this.country,
    this.statusId,
    this.comment,
    this.mainLanguage,
    this.secondaryLanguage,
    this.crmOrganisationId,
    this.id,
    this.uuid,
    this.createdBy,
    this.createdAt,
    this.deletedAt,
    this.status,
    this.thumbnail,
  });

  CrmLead.fromJson(Map<String, dynamic> json) {
    isPro = json["isPro"];
    firstName = json["firstName"];
    lastName = json["lastName"];
    email = json["email"];
    website = json["website"];
    mobilePhone = json["mobilePhone"];
    mobilePrefix = json["mobilePrefix"];
    fixPhone = json["fixPhone"];
    fixPrefix = json["fixPrefix"];
    organisationId = json["organisationId"];
    street = json["street"];
    zip = json["zip"];
    city = json["city"];
    state = json["state"];
    country = json["country"];
    statusId = json["statusId"];
    comment = json["comment"];
    mainLanguage = json["mainLanguage"];
    secondaryLanguage = json["secondaryLanguage"];
    crmOrganisationId = json["crmOrganisationId"];
    id = json["id"];
    uuid = json["uuid"];
    createdBy = json["createdBy"];
    createdAt = json["createdAt"];
    deletedAt = json["deletedAt"];
    thumbnail = json["thumbnail"];
    status = json["status"] == null ? null : CrmStatus.fromJson(json["status"]);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["isPro"] = isPro;
    _data["firstName"] = firstName;
    _data["lastName"] = lastName;
    _data["email"] = email;
    _data["website"] = website;
    _data["mobilePhone"] = mobilePhone;
    _data["mobilePrefix"] = mobilePrefix;
    _data["fixPhone"] = fixPhone;
    _data["fixPrefix"] = fixPrefix;
    _data["organisationId"] = organisationId;
    _data["street"] = street;
    _data["zip"] = zip;
    _data["city"] = city;
    _data["state"] = state;
    _data["country"] = country;
    _data["statusId"] = statusId;
    _data["comment"] = comment;
    _data["mainLanguage"] = mainLanguage;
    _data["secondaryLanguage"] = secondaryLanguage;
    _data["crmOrganisationId"] = crmOrganisationId;
    _data["id"] = id;
    _data["uuid"] = uuid;
    _data["createdBy"] = createdBy;
    _data["createdAt"] = createdAt;
    _data["deletedAt"] = deletedAt;
    _data["thumbnail"] = thumbnail;
    if (status != null) {
      _data["status"] = status?.toJson();
    }
    return _data;
  }

  CrmLead copyWith({
    int? isPro,
    String? firstName,
    String? lastName,
    String? email,
    String? website,
    String? mobilePhone,
    String? mobilePrefix,
    String? fixPhone,
    String? fixPrefix,
    int? organisationId,
    String? street,
    String? zip,
    String? city,
    String? state,
    String? country,
    int? statusId,
    String? comment,
    String? mainLanguage,
    String? secondaryLanguage,
    int? crmOrganisationId,
    int? id,
    String? uuid,
    int? createdBy,
    int? createdAt,
    int? deletedAt,
    CrmStatus? status,
    String? thumbnail,
  }) =>
      CrmLead(
        isPro: isPro ?? this.isPro,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        email: email ?? this.email,
        website: website ?? this.website,
        mobilePhone: mobilePhone ?? this.mobilePhone,
        mobilePrefix: mobilePrefix ?? this.mobilePrefix,
        fixPhone: fixPhone ?? this.fixPhone,
        fixPrefix: fixPrefix ?? this.fixPrefix,
        organisationId: organisationId ?? this.organisationId,
        street: street ?? this.street,
        zip: zip ?? this.zip,
        city: city ?? this.city,
        state: state ?? this.state,
        country: country ?? this.country,
        statusId: statusId ?? this.statusId,
        comment: comment ?? this.comment,
        mainLanguage: mainLanguage ?? this.mainLanguage,
        secondaryLanguage: secondaryLanguage ?? this.secondaryLanguage,
        crmOrganisationId: crmOrganisationId ?? this.crmOrganisationId,
        id: id ?? this.id,
        uuid: uuid ?? this.uuid,
        createdBy: createdBy ?? this.createdBy,
        createdAt: createdAt ?? this.createdAt,
        deletedAt: deletedAt ?? this.deletedAt,
        status: status ?? this.status,
        thumbnail: thumbnail ?? this.thumbnail,
      );
}
