class HomeCountryAvaliable {
  String? countryCode;
  String? countryFlag;
  String? countryName;
  String? homesCountryPictureUrl;
  String? topBannerHomePictureUrl;
  String? topBannerHomeVideoUrl;
  String? currency;

  HomeCountryAvaliable(
      {this.countryCode,
      this.countryFlag,
      this.countryName,
      this.homesCountryPictureUrl,
      this.topBannerHomePictureUrl,
      this.topBannerHomeVideoUrl,
      this.currency});

  HomeCountryAvaliable.fromJson(Map<String, dynamic> json) {
    countryCode = json["countryCode"];
    countryFlag = json["countryFlag"];
    countryName = json["countryName"];
    homesCountryPictureUrl = json["homesCountryPictureUrl"];
    topBannerHomePictureUrl = json["topBannerHomePictureUrl"];
    topBannerHomeVideoUrl = json["topBannerHomeVideoUrl"];
    currency = json["currency"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> _data = <String, dynamic>{};
    _data["countryCode"] = countryCode;
    _data["countryFlag"] = countryFlag;
    _data["countryName"] = countryName;
    _data["homesCountryPictureUrl"] = homesCountryPictureUrl;
    _data["topBannerHomePictureUrl"] = topBannerHomePictureUrl;
    _data["topBannerHomeVideoUrl"] = topBannerHomeVideoUrl;
    _data["currency"] = currency;
    return _data;
  }

  HomeCountryAvaliable copyWith({
    String? countryCode,
    String? countryFlag,
    String? countryName,
    String? homesCountryPictureUrl,
    String? topBannerHomePictureUrl,
    String? topBannerHomeVideoUrl,
    String? currency,
  }) =>
      HomeCountryAvaliable(
        countryCode: countryCode ?? this.countryCode,
        countryFlag: countryFlag ?? this.countryFlag,
        countryName: countryName ?? this.countryName,
        homesCountryPictureUrl:
            homesCountryPictureUrl ?? this.homesCountryPictureUrl,
        topBannerHomePictureUrl:
            topBannerHomePictureUrl ?? this.topBannerHomePictureUrl,
        topBannerHomeVideoUrl:
            topBannerHomeVideoUrl ?? this.topBannerHomeVideoUrl,
        currency: currency ?? this.currency,
      );
}
