import '../resources.dart';

class TicketRepo {
  TicketRepo._();

  static TicketRepo? _instance;

  factory TicketRepo([AppApi? api]) {
    if (_instance == null) _instance = TicketRepo._();
    _instance!._api = api ?? AppApiImp();
    return _instance!;
  }

  late AppApi _api;

  Future<ListTicket?> v2_getMyTicketsFromAgent(ticketStatusId) async {
    NetworkResponse response =
        await _api.v2_getMyTicketsFromAgent(ticketStatusId);
    return response.data;
  }

  Future<ListTicket?> v2_getMyTicketsFromCustomer(params) async {
    NetworkResponse response =
        await _api.v2_getMyTicketsFromCustomer(params);
    return response.data;
  }

  Future<bool> v2_answerToTicketFromAgent({ticketId, answerContent}) async {
    NetworkResponse response = await _api.v2_answerToTicketFromAgent(
        {'ticketId': ticketId, 'answerContent': answerContent});
    return response.data ?? false;
  }

  Future<bool> v2_answerToTicketFromCustomer({ticketId, answerContent}) async {
    NetworkResponse response = await _api.v2_answerToTicketFromCustomer(
        {'ticketId': ticketId, 'answerContent': answerContent});
    return response.data ?? false;
  }

  Future<bool> v2_assignTicketToAgents({ticketId, proId}) async {
    NetworkResponse response = await _api
        .v2_assignTicketToAgents({'ticketId': ticketId, 'proId': proId});
    return response.data ?? false;
  }

  Future<List<TicketAnswer>> getAnswersOfTicket(ticketId) async {
    NetworkResponse response = await _api.getAnswersOfTicket(ticketId);
    return response.data ?? [];
  }

  Future<List<AgentModel>> v2_getAgentList() async {
    NetworkResponse response = await _api.v2_getAgentList();
    return response.data ?? [];
  }

  Future<TicketDetail?> v2_postTicketByCustomer(params) async {
    NetworkResponse response = await _api.v2_postTicketByCustomer(params);
    return response.data;
  }
}
